Bug 1195573 (dropbox-api-command) - Review Request: dropbox-api-command - Dropbox API wrapper command
Summary: Review Request: dropbox-api-command - Dropbox API wrapper command
Keywords:
Status: CLOSED ERRATA
Alias: dropbox-api-command
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Petr Šabata
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2015-02-24 06:10 UTC by Ben Boeckel
Modified: 2015-07-30 13:56 UTC (History)
5 users (show)

Fixed In Version: dropbox-api-command-1.17-5.fc22
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-07-19 16:25:46 UTC
Type: ---
psabata: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Ben Boeckel 2015-02-24 06:10:47 UTC
Spec URL: http://mathstuf.fedorapeople.org//dropbox-api-command.spec
SRPM URL: http://mathstuf.fedorapeople.org//dropbox-api-command-1.17-1.fc23.src.rpm

Description:
Dropbox API wrapper command.

Comment 1 Ben Boeckel 2015-02-24 06:11:41 UTC
Koji scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=9048548

Comment 2 Victoria Martinez de la Cruz 2015-02-25 00:35:54 UTC
This is an unofficial review only.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


Issues:
=======
- Dirs in package are owned also by: /usr/share/perl5/App(perl)
  http://fedoraproject.org/wiki/Packaging:Guidelines#Duplication_of_system_libraries

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[!]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/share/perl5/App(perl)
[-]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Perl:
[x]: Package contains the mandatory BuildRequires and Requires:.

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: dropbox-api-command-1.17-1.fc23.noarch.rpm
          dropbox-api-command-1.17-1.fc23.src.rpm
dropbox-api-command.noarch: W: no-version-in-last-changelog
dropbox-api-command.noarch: W: no-manual-page-for-binary dropbox-api
dropbox-api-command.noarch: W: no-manual-page-for-binary upload-to-dropbox
dropbox-api-command.src: W: no-version-in-last-changelog
dropbox-api-command.src: W: strange-permission dropbox-api-command-446e6e382f7e79744549f72436cd5407cefac8db.tar.gz 0640L
dropbox-api-command.src: W: strange-permission dropbox-api-command.spec 0640L
2 packages and 0 specfiles checked; 0 errors, 6 warnings.



Requires
--------
dropbox-api-command (rpmlib, GLIBC filtered):
    /bin/bash
    /usr/bin/env
    perl(:MODULE_COMPAT_5.20.2)
    perl(Cwd)
    perl(Data::Dumper)
    perl(DateTime)
    perl(DateTime::Format::Strptime)
    perl(Encode)
    perl(Encode::Locale)
    perl(File::Basename)
    perl(File::Spec::Functions)
    perl(File::Temp)
    perl(Getopt::Std)
    perl(JSON)
    perl(Path::Class)
    perl(WebService::Dropbox)
    perl(strict)
    perl(warnings)



Provides
--------
dropbox-api-command:
    dropbox-api-command
    perl(App::dropboxapi)



Source checksums
----------------
https://github.com/s-aska/dropbox-api-command/archive/446e6e382f7e79744549f72436cd5407cefac8db/dropbox-api-command-446e6e382f7e79744549f72436cd5407cefac8db.tar.gz :
  CHECKSUM(SHA256) this package     : afd1d29ab50383cf851ee0afffa15c0546182484ec9e8dd248c5cc58143137e5
  CHECKSUM(SHA256) upstream package : afd1d29ab50383cf851ee0afffa15c0546182484ec9e8dd248c5cc58143137e5



Command line :/usr/bin/fedora-review -b 1195573 --mock-config fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Perl
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 3 Ben Boeckel 2015-02-27 04:13:08 UTC
(In reply to Victoria Martinez de la Cruz from comment #2)
> This is an unofficial review only.

Thanks!

> - Dirs in package are owned also by: /usr/share/perl5/App(perl)

Whoops. Fixed.

> Checking: dropbox-api-command-1.17-1.fc23.noarch.rpm
>           dropbox-api-command-1.17-1.fc23.src.rpm
> dropbox-api-command.noarch: W: no-version-in-last-changelog

Added.

> dropbox-api-command.noarch: W: no-manual-page-for-binary dropbox-api
> dropbox-api-command.noarch: W: no-manual-page-for-binary upload-to-dropbox

Bug filed upstream: https://github.com/s-aska/dropbox-api-command/issues/26

> dropbox-api-command.src: W: no-version-in-last-changelog
> dropbox-api-command.src: W: strange-permission
> dropbox-api-command-446e6e382f7e79744549f72436cd5407cefac8db.tar.gz 0640L
> dropbox-api-command.src: W: strange-permission dropbox-api-command.spec 0640L

Caused by my umask (027); it's fine from Fedora's infra.

Comment 5 Petr Šabata 2015-02-27 15:48:55 UTC
I'll do the rest of the review :)

Comment 6 Petr Šabata 2015-02-27 16:01:11 UTC
1. I would use the release URL instead of just pointing to the commit (which could be something entirely different and nobody will notice).  For example https://github.com/s-aska/%{name}/archive/%{version}.tar.gz should work just fine.  The tarball filename will be just the version plus extension but that doesn't really matter.

2. Missing buildtime dependencies: perl, perl(CPAN::Meta), perl(CPAN::Meta::Prereqs), perl(File::Basename), perl(File::Spec), perl(strict), perl(utf8), perl(warnings)

3. Use perl macros for the perl lib paths in %files; changing %{_datadir}/perl5/App/dropboxapi.pm to %{perl_vendorlib}/* would be fine.

4. A more useful %description would be nice.  This isn't necessary.

5. You shouldn't need to define prefix, I suppose?

6. Perhaps the project Github page would work better for the URL.

Comment 7 Ben Boeckel 2015-02-27 17:20:04 UTC
(In reply to Petr Šabata from comment #6)
> 1. I would use the release URL instead of just pointing to the commit (which
> could be something entirely different and nobody will notice).  For example
> https://github.com/s-aska/%{name}/archive/%{version}.tar.gz should work just
> fine.  The tarball filename will be just the version plus extension but that
> doesn't really matter.

https://fedoraproject.org/wiki/Packaging:SourceURL#Github

> 2. Missing buildtime dependencies: perl, perl(CPAN::Meta),
> perl(CPAN::Meta::Prereqs), perl(File::Basename), perl(File::Spec),
> perl(strict), perl(utf8), perl(warnings)

Hmm. Is there a way to detect these automatically? I think perl(WebService::Dropbox) also necessary. Or is that just a runtime dep? I'm not all that well-versed in Perl stuff.

> 3. Use perl macros for the perl lib paths in %files; changing
> %{_datadir}/perl5/App/dropboxapi.pm to %{perl_vendorlib}/* would be fine.

Ah, I used rpmdev-newspec -t perl for this. Will do.

> 4. A more useful %description would be nice.  This isn't necessary.

I'll put something together.

> 5. You shouldn't need to define prefix, I suppose?

rpmdev-newspec's doing; I'll remove it if that's more modern.

> 6. Perhaps the project Github page would work better for the URL.

Probably. Will do.

Comment 8 Petr Šabata 2015-02-27 17:53:19 UTC
(In reply to Ben Boeckel from comment #7)
> (In reply to Petr Šabata from comment #6)
> > 1. I would use the release URL instead of just pointing to the commit (which
> > could be something entirely different and nobody will notice).  For example
> > https://github.com/s-aska/%{name}/archive/%{version}.tar.gz should work just
> > fine.  The tarball filename will be just the version plus extension but that
> > doesn't really matter.
> 
> https://fedoraproject.org/wiki/Packaging:SourceURL#Github

Indeed.  Let me quote your link:

"If the upstream does not create tarballs for releases, you can use this mechanism to produce them. If the upstream does create tarballs you should use them as tarballs provide an easier trail for people auditing the packages."

Your upstream provides tarballs.
https://github.com/s-aska/dropbox-api-command/releases

> > 2. Missing buildtime dependencies: perl, perl(CPAN::Meta),
> > perl(CPAN::Meta::Prereqs), perl(File::Basename), perl(File::Spec),
> > perl(strict), perl(utf8), perl(warnings)
> 
> Hmm. Is there a way to detect these automatically? I think
> perl(WebService::Dropbox) also necessary. Or is that just a runtime dep? I'm
> not all that well-versed in Perl stuff.

Yes, perl(WebService::Dropbox) is just a runtime dependency and is generated automatically by rpmbuild (via perl-generators).  It's required by script/dropbox-api which isn't used neither during %build nor %check phases.

You can use the `tangerine' command (from perl-Tangerine) to check perl files for what modules they provide or require.  For example in your case, to see buildtime deps you could run `tangerine Build.PL lib t'.

Comment 11 Petr Šabata 2015-03-02 09:52:06 UTC
(In reply to Ben Boeckel from comment #10)
> Spec URL: http://mathstuf.fedorapeople.org//dropbox-api-command.spec
> SRPM URL:
> http://mathstuf.fedorapeople.org//dropbox-api-command-1.17-4.fc23.src.rpm
> 
> http://koji.fedoraproject.org/koji/taskinfo?taskID=9096834
> 
> So --prefix is required and %{perl_vendorlib} is the wrong path.

No, neither is true ;) The problem is you're using non-existant Module::Build option; I missed that earlier.  Change `INSTALLDIRS' (used by ExtUtils::MakeMaker) to `installdirs' or `--installdirs' (the latter also works with Module::Build::Tiny).  Then you will be installing to the correct path, you won't have to define prefix and you will be able to use the standard noarch perl path macro.

Also, the `perl' buildtime dependency is still missing.

And I ack the rest of the issues were fixed.

Comment 13 Ben Boeckel 2015-03-03 01:13:55 UTC
As I hit "Save Changes", I realized I forgot to add BR: perl. Added locally. I can upload again if you want or import it with the change.

Comment 14 Petr Šabata 2015-03-03 09:38:41 UTC
It's okay, I believe you.  No need to respin the review.

Since this is a perl package, please, add perl-sig to InitialCC when requesting branches.

Approving.

Comment 15 Ben Boeckel 2015-03-03 13:08:48 UTC
Thanks!

New Package SCM Request
=======================
Package Name: dropbox-api-command
Short Description: Dropbox API wrapper command
Upstream URL: https://github.com/s-aska/dropbox-api-command
Owners: mathstuf
Branches: f22 f21 f20
InitialCC: perl-sig

Comment 16 Gwyn Ciesla 2015-03-03 13:18:22 UTC
Git done (by process-git-requests).

Comment 17 Petr Šabata 2015-05-14 08:47:09 UTC
Ben, feel free to push and build the package.

Comment 18 Petr Šabata 2015-06-15 16:23:38 UTC
Ping?

Comment 19 Ben Boeckel 2015-07-19 16:25:46 UTC
Sorry for the delays. Now built for rawhide. Building for other releases as well.

Comment 20 Fedora Update System 2015-07-20 04:20:35 UTC
dropbox-api-command-1.17-5.fc22 has been submitted as an update for Fedora 22.
https://admin.fedoraproject.org/updates/dropbox-api-command-1.17-5.fc22

Comment 21 Fedora Update System 2015-07-20 04:20:53 UTC
dropbox-api-command-1.17-5.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/dropbox-api-command-1.17-5.fc21

Comment 22 Fedora Update System 2015-07-30 13:55:56 UTC
dropbox-api-command-1.17-5.fc21 has been pushed to the Fedora 21 stable repository.

Comment 23 Fedora Update System 2015-07-30 13:56:39 UTC
dropbox-api-command-1.17-5.fc22 has been pushed to the Fedora 22 stable repository.


Note You need to log in before you can comment on or make changes to this bug.